#ifndef TERM_K_H
#define TERM_K_H

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

static const size_t VGA_WIDTH = 80;
static const size_t VGA_HEIGHT = 25;

struct kVGATerm {
	size_t terminal_row;
	size_t terminal_column;
	uint8_t terminal_color;
	uint16_t* terminal_buffer;
};
typedef struct kVGATerm kVGATerm;
void terminal_initialize(kVGATerm *term);

void terminal_shiftup(kVGATerm *term);


void terminal_setcolor(kVGATerm *term, uint8_t color);


void terminal_putentryat(kVGATerm *term, char c, uint8_t color, size_t x, size_t y);


void terminal_write(kVGATerm *term, const char* data, size_t size);

void terminal_writestring(kVGATerm *term, const char * data);

void terminal_putchar(kVGATerm *term, char c);

enum vga_color {
	VGA_COLOR_BLACK = 0,
	VGA_COLOR_BLUE = 1,
	VGA_COLOR_GREEN = 2,
	VGA_COLOR_CYAN = 3,
	VGA_COLOR_RED = 4,
	VGA_COLOR_MAGENTA = 5,
	VGA_COLOR_BROWN = 6,
	VGA_COLOR_LIGHT_GREY = 7,
	VGA_COLOR_DARK_GREY = 8,
	VGA_COLOR_LIGHT_BLUE = 9,
	VGA_COLOR_LIGHT_GREEN = 10,
	VGA_COLOR_LIGHT_CYAN = 11,
	VGA_COLOR_LIGHT_RED = 12,
	VGA_COLOR_LIGHT_MAGENTA = 13,
	VGA_COLOR_LIGHT_BROWN = 14,
	VGA_COLOR_WHITE = 15,
};

static inline uint8_t vga_entry_color(enum vga_color fg, enum vga_color bg);


static inline uint16_t vga_entry(unsigned char uc, uint8_t color);

size_t strlen(const char* str);


#endif
